c21c3fd7c2bd589bc0799642a137aa50e91f828d
[doctor.git] / tests / run.sh
1 #!/bin/bash -e
2 ##############################################################################
3 # Copyright (c) 2016 NEC Corporation and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 # Configuration
12
13 [[ "${CI_DEBUG:-true}" == [Tt]rue ]] && set -x
14
15 IMAGE_URL=https://launchpad.net/cirros/trunk/0.3.0/+download/cirros-0.3.0-x86_64-disk.img
16 #if an existing image name is provided in the enviroment, use that one
17 IMAGE_NAME=${IMAGE_NAME:-cirros}
18 IMAGE_FILE="${IMAGE_NAME}.img"
19 IMAGE_FORMAT=qcow2
20 VM_BASENAME=doctor_vm
21 VM_FLAVOR=m1.tiny
22 #if VM_COUNT set, use that instead
23 VM_COUNT=${VM_COUNT:-1}
24 NET_NAME=doctor_net
25 NET_CIDR=192.168.168.0/24
26 ALARM_BASENAME=doctor_alarm
27 CONSUMER_PORT=12346
28 DOCTOR_USER=doctor
29 DOCTOR_PW=doctor
30 DOCTOR_PROJECT=doctor
31 DOCTOR_ROLE=_member_
32 PROFILER_TYPE=${PROFILER_TYPE:-none}
33
34 TOP_DIR=$(cd $(dirname "$0") && pwd)
35
36 as_doctor_user="--os-username $DOCTOR_USER --os-password $DOCTOR_PW
37                 --os-project-name $DOCTOR_PROJECT --os-tenant-name $DOCTOR_PROJECT"
38 # NOTE: ceilometer command still requires '--os-tenant-name'.
39 #ceilometer="ceilometer ${as_doctor_user/--os-project-name/--os-tenant-name}"
40 ceilometer="ceilometer $as_doctor_user"
41 as_admin_user="--os-username admin --os-project-name $DOCTOR_PROJECT
42                --os-tenant-name $DOCTOR_PROJECT"
43
44
45 # Functions
46
47 get_compute_host_info() {
48     # get computer host info which first VM boot in as admin user
49     COMPUTE_HOST=$(openstack $as_admin_user server show ${VM_BASENAME}1 |
50                    grep "OS-EXT-SRV-ATTR:host" | awk '{ print $4 }')
51     compute_host_in_undercloud=${COMPUTE_HOST%%.*}
52     die_if_not_set $LINENO COMPUTE_HOST "Failed to get compute hostname"
53
54     get_compute_ip_from_hostname $COMPUTE_HOST
55
56     echo "COMPUTE_HOST=$COMPUTE_HOST"
57     echo "COMPUTE_IP=$COMPUTE_IP"
58
59     # verify connectivity to target compute host
60     ping -c 1 "$COMPUTE_IP"
61     if [[ $? -ne 0 ]] ; then
62         die $LINENO "Can not ping to computer host"
63     fi
64
65     # verify ssh to target compute host
66     ssh $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP" 'exit'
67     if [[ $? -ne 0 ]] ; then
68         die $LINENO "Can not ssh to computer host"
69     fi
70 }
71
72 # TODO(r-mibu): update this function to support consumer instance
73 #               and migrate this function into installer lib
74 get_consumer_ip___to_be_removed() {
75     local get_consumer_command="ip route get $COMPUTE_IP | awk '/ src /{print \$NF}'"
76     if is_installer apex; then
77         CONSUMER_IP=$(sudo ssh $ssh_opts root@$INSTALLER_IP \
78                       "$get_consumer_command")
79     elif is_installer fuel; then
80         CONSUMER_IP=$(sudo sshpass -p r00tme ssh $ssh_opts root@${INSTALLER_IP} \
81                       "$get_consumer_command")
82     elif is_installer local; then
83         CONSUMER_IP=`$get_consumer_command`
84     fi
85     echo "CONSUMER_IP=$CONSUMER_IP"
86
87     die_if_not_set $LINENO CONSUMER_IP "Could not get CONSUMER_IP."
88 }
89
90 download_image() {
91     #if a different name was provided for the image in the enviroment there's no need to download the image
92     use_existing_image=false
93     openstack image list | grep -q " $IMAGE_NAME " && use_existing_image=true
94
95     if [[ "$use_existing_image" == false ]] ; then
96         [ -e "$IMAGE_FILE" ] && return 0
97         wget "$IMAGE_URL" -o "$IMAGE_FILE"
98     fi
99 }
100
101 register_image() {
102     openstack image list | grep -q " $IMAGE_NAME " && return 0
103     openstack image create "$IMAGE_NAME" \
104                            --public \
105                            --disk-format "$IMAGE_FORMAT" \
106                            --container-format bare \
107                            --file "$IMAGE_FILE"
108 }
109
110 create_test_user() {
111     openstack project list | grep -q " $DOCTOR_PROJECT " || {
112         openstack project create --description "Doctor Project" \
113                                  "$DOCTOR_PROJECT"
114     }
115     openstack user list | grep -q " $DOCTOR_USER " || {
116         openstack user create "$DOCTOR_USER" --password "$DOCTOR_PW" \
117                               --project "$DOCTOR_PROJECT"
118     }
119     openstack role show "$DOCTOR_ROLE" | grep -q " $DOCTOR_ROLE " || {
120         openstack role create "$DOCTOR_ROLE"
121     }
122     openstack role assignment list --user "$DOCTOR_USER" \
123     --project "$DOCTOR_PROJECT" --names | grep -q " $DOCTOR_ROLE " || {
124         openstack role add "$DOCTOR_ROLE" --user "$DOCTOR_USER" \
125                            --project "$DOCTOR_PROJECT"
126     }
127     openstack role assignment list --user admin --project "$DOCTOR_PROJECT" \
128     --names | grep -q " admin " || {
129         openstack role add admin --user admin --project "$DOCTOR_PROJECT"
130     }
131     # tojuvone: openstack quota show is broken and have to use nova
132     # https://bugs.launchpad.net/manila/+bug/1652118
133     # Note! while it is encouraged to use openstack client it has proven
134     # quite buggy.
135     # QUOTA=$(openstack quota show $DOCTOR_PROJECT)
136     DOCTOR_QUOTA=$(nova quota-show --tenant $DOCTOR_PROJECT)
137     # We make sure that quota allows number of instances and cores
138     OLD_INSTANCE_QUOTA=$(echo "${DOCTOR_QUOTA}" | grep " instances " | \
139                          awk '{print $4}')
140     if [ $OLD_INSTANCE_QUOTA -lt $VM_COUNT ]; then
141         openstack quota set --instances $VM_COUNT \
142                   $DOCTOR_USER
143     fi
144     OLD_CORES_QUOTA=$(echo "${DOCTOR_QUOTA}" | grep " cores " | \
145                       awk '{print $4}')
146     if [ $OLD_CORES_QUOTA -lt $VM_COUNT ]; then
147         openstack quota set --cores $VM_COUNT \
148                   $DOCTOR_USER
149     fi
150 }
151
152 remove_test_user() {
153     openstack project list | grep -q " $DOCTOR_PROJECT " && {
154         openstack role assignment list --user admin \
155         --project "$DOCTOR_PROJECT" --names | grep -q " admin " && {
156             openstack role remove admin --user admin --project "$DOCTOR_PROJECT"
157         }
158         openstack user list | grep -q " $DOCTOR_USER " && {
159             openstack role assignment list --user "$DOCTOR_USER" \
160             --project "$DOCTOR_PROJECT" --names | grep -q " $DOCTOR_ROLE " && {
161                 openstack role remove "$DOCTOR_ROLE" --user "$DOCTOR_USER" \
162                 --project "$DOCTOR_PROJECT"
163             }
164             openstack user delete "$DOCTOR_USER"
165         }
166         openstack project delete "$DOCTOR_PROJECT"
167     }
168 }
169
170 boot_vm() {
171     # test VM done with test user, so can test non-admin
172
173     if ! openstack $as_doctor_user network show $NET_NAME; then
174         openstack $as_doctor_user network create $NET_NAME
175     fi
176     if ! openstack $as_doctor_user subnet show $NET_NAME; then
177         openstack $as_doctor_user subnet create $NET_NAME \
178             --network $NET_NAME --subnet-range $NET_CIDR --no-dhcp
179     fi
180     net_id=$(openstack $as_doctor_user network show $NET_NAME -f value -c id)
181
182     servers=$(openstack $as_doctor_user server list)
183     for i in `seq $VM_COUNT`; do
184         echo "${servers}" | grep -q " $VM_BASENAME$i " && continue
185         openstack $as_doctor_user server create --flavor "$VM_FLAVOR" \
186             --image "$IMAGE_NAME" --nic net-id=$net_id "$VM_BASENAME$i"
187     done
188     sleep 1
189 }
190
191 create_alarm() {
192     # get vm_id as test user
193     alarm_list=$($ceilometer alarm-list)
194     vms=$(openstack $as_doctor_user server list)
195     for i in `seq $VM_COUNT`; do
196         echo "${alarm_list}" | grep -q " $ALARM_BASENAME$i " || {
197             vm_id=$(echo "${vms}" | grep " $VM_BASENAME$i " | awk '{print $2}')
198             # TODO(r-mibu): change notification endpoint from localhost to the
199             # consumer. IP address (functest container).
200             $ceilometer alarm-event-create \
201                        --name "$ALARM_BASENAME$i" \
202                        --alarm-action "http://localhost:$CONSUMER_PORT/failure" \
203                        --description "VM failure" \
204                        --enabled True \
205                        --repeat-actions False \
206                        --severity "moderate" \
207                        --event-type compute.instance.update \
208                        -q "traits.state=string::error; \
209                        traits.instance_id=string::$vm_id"
210             }
211      done
212 }
213
214 start_monitor() {
215     pgrep -f "python monitor.py" && return 0
216     sudo -E python monitor.py "$COMPUTE_HOST" "$COMPUTE_IP" "$INSPECTOR_TYPE" \
217         > monitor.log 2>&1 &
218 }
219
220 stop_monitor() {
221     pgrep -f "python monitor.py" || return 0
222     sudo kill $(pgrep -f "python monitor.py")
223 }
224
225 start_consumer() {
226     pgrep -f "python consumer.py" && return 0
227     python consumer.py "$CONSUMER_PORT" > consumer.log 2>&1 &
228
229     # NOTE(r-mibu): create tunnel to the controller nodes, so that we can
230     # avoid some network problems dpends on infra and installers.
231     # This tunnel will be terminated by stop_consumer() or after 10 mins passed.
232     if ! is_installer local; then
233         for ip in $CONTROLLER_IPS
234         do
235             forward_rule="-R $CONSUMER_PORT:localhost:$CONSUMER_PORT"
236             tunnel_command="sudo ssh $ssh_opts_cpu $COMPUTE_USER@$ip $forward_rule sleep 600"
237             $tunnel_command > "ssh_tunnel.${ip}.log" 2>&1 < /dev/null &
238         done
239     fi
240 }
241
242 stop_consumer() {
243     pgrep -f "python consumer.py" || return 0
244     kill $(pgrep -f "python consumer.py")
245
246     # NOTE(r-mibu): terminate tunnels to the controller nodes
247     if ! is_installer local; then
248         for ip in $CONTROLLER_IPS
249         do
250             forward_rule="-R $CONSUMER_PORT:localhost:$CONSUMER_PORT"
251             tunnel_command="sudo ssh $ssh_opts_cpu $COMPUTE_USER@$ip $forward_rule sleep 600"
252             kill $(pgrep -f "$tunnel_command")
253         done
254     fi
255 }
256
257 wait_for_vm_launch() {
258     echo "waiting for vm launch..."
259
260     count=0
261     while [[ ${count} -lt 60 ]]
262     do
263         active_count=0
264         vms=$(openstack $as_doctor_user server list)
265         for i in `seq $VM_COUNT`; do
266             state=$(echo "${vms}" | grep " $VM_BASENAME$i " | awk '{print $6}')
267             if [[ "$state" == "ACTIVE" ]]; then
268                 active_count=$(($active_count+1))
269             elif [[ "$state" == "ERROR" ]]; then
270                 die $LINENO "vm state $VM_BASENAME$i is ERROR"
271             else
272                 #This VM not yet active
273                 count=$(($count+1))
274                 sleep 5
275                 continue
276             fi
277         done
278         [[ $active_count -eq $VM_COUNT ]] && {
279             echo "get computer host info..."
280             get_compute_host_info
281             VMS_ON_FAILED_HOST=$(openstack $as_doctor_user server list --host \
282                          $COMPUTE_HOST | grep " ${VM_BASENAME}" |  wc -l)
283             return 0
284         }
285         #Not all VMs active
286         count=$(($count+1))
287         sleep 5
288     done
289     die $LINENO "Time out while waiting for VM launch"
290 }
291
292 inject_failure() {
293     echo "disabling network of compute host [$COMPUTE_HOST] for 3 mins..."
294     cat > disable_network.sh << 'END_TXT'
295 #!/bin/bash -x
296 dev=$(sudo ip a | awk '/ @COMPUTE_IP@\//{print $7}')
297 [[ -n "$dev" ]] || dev=$(sudo ip a | awk '/ @COMPUTE_IP@\//{print $5}')
298 sleep 1
299 sudo ip link set $dev down
300 echo "doctor set link down at" $(date "+%s.%N")
301 sleep 180
302 sudo ip link set $dev up
303 sleep 1
304 END_TXT
305     sed -i -e "s/@COMPUTE_IP@/$COMPUTE_IP/" disable_network.sh
306     chmod +x disable_network.sh
307     scp $ssh_opts_cpu disable_network.sh "$COMPUTE_USER@$COMPUTE_IP:"
308     ssh $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP" 'nohup ./disable_network.sh > disable_network.log 2>&1 &'
309     # use host time to get rid of potential time sync deviation between nodes
310     triggered=$(date "+%s.%N")
311 }
312
313 wait_consumer() {
314     local interval=1
315     local rounds=$(($1 / $interval))
316     for i in `seq $rounds`; do
317         notified_count=$(grep "doctor consumer notified at" consumer.log | wc -l)
318         if [[ $notified_count -eq  $VMS_ON_FAILED_HOST ]]; then
319             return 0
320         fi
321         sleep $interval
322     done
323     die $LINENO "Consumer hasn't received fault notification."
324 }
325
326 calculate_notification_time() {
327     wait_consumer 60
328     #keep 'at' as the last keyword just before the value, and
329     #use regex to get value instead of the fixed column
330     detected=$(grep "doctor monitor detected at" monitor.log |\
331                sed -e "s/^.* at //")
332     notified=$(grep "doctor consumer notified at" consumer.log |\
333                sed -e "s/^.* at //" | tail -1)
334
335     echo "$notified $detected" | \
336         awk '{
337             d = $1 - $2;
338             if (d < 1 && d > 0) { print d " OK"; exit 0 }
339             else { print d " NG"; exit 1 }
340         }'
341 }
342
343 check_host_status() {
344     # Check host related to first Doctor VM is in wanted state
345     # $1    Expected state
346     # $2    Seconds to wait to have wanted state
347     expected_state=$1
348     local interval=5
349     local rounds=$(($2 / $interval))
350     for i in `seq $rounds`; do
351         host_status_line=$(openstack $as_doctor_user --os-compute-api-version \
352                            2.16 server show ${VM_BASENAME}1 | grep "host_status")
353         host_status=$(echo $host_status_line | awk '{print $4}')
354         die_if_not_set $LINENO host_status "host_status not reported by: nova show ${VM_BASENAME}1"
355         if [[ "$expected_state" =~ "$host_status" ]] ; then
356             echo "${VM_BASENAME}1 showing host_status: $host_status"
357             return 0
358         else
359             sleep $interval
360         fi
361     done
362     if [[ "$expected_state" =~ "$host_status" ]] ; then
363         echo "${VM_BASENAME}1 showing host_status: $host_status"
364     else
365         die $LINENO  "host_status:$host_status not equal to expected_state: $expected_state"
366     fi
367 }
368
369 unset_forced_down_hosts() {
370     # for debug
371     openstack compute service list --service nova-compute
372
373     downed_computes=$(openstack compute service list --service nova-compute \
374                       -f value -c Host -c State | grep ' down$' \
375                       | sed -e 's/ *down$//')
376     echo "downed_computes: $downed_computes"
377     for host in $downed_computes
378     do
379         # TODO(r-mibu): use openstack client
380         #openstack compute service set --up $host nova-compute
381         nova service-force-down --unset $host nova-compute
382     done
383
384     echo "waiting disabled compute host back to be enabled..."
385     wait_until 'openstack compute service list --service nova-compute
386                 -f value -c State | grep -q down' 240 5
387
388     for host in $downed_computes
389     do
390         # TODO(r-mibu): improve 'get_compute_ip_from_hostname'
391         get_compute_ip_from_hostname $host
392         wait_until "! ping -c 1 $COMPUTE_IP" 120 5
393     done
394 }
395
396 collect_logs() {
397     if [[ -n "$COMPUTE_IP" ]];then
398         scp $ssh_opts_cpu "$COMPUTE_USER@$COMPUTE_IP:disable_network.log" .
399     fi
400
401     # TODO(yujunz) collect other logs, e.g. nova, aodh
402 }
403
404 run_profiler() {
405     if [[ "$PROFILER_TYPE" == "poc" ]]; then
406         linkdown=$(grep "doctor set link down at " disable_network.log |\
407                   sed -e "s/^.* at //")
408         vmdown=$(grep "doctor mark vm.* error at" inspector.log |tail -n 1 |\
409                  sed -e "s/^.* at //")
410         hostdown=$(grep "doctor mark host.* down at" inspector.log |\
411                  sed -e "s/^.* at //")
412
413         # TODO(yujunz) check the actual delay to verify time sync status
414         # expected ~1s delay from $trigger to $linkdown
415         relative_start=${linkdown}
416         export DOCTOR_PROFILER_T00=$(python -c \
417           "print(int(($linkdown-$relative_start)*1000))")
418         export DOCTOR_PROFILER_T01=$(python -c \
419           "print(int(($detected-$relative_start)*1000))")
420         export DOCTOR_PROFILER_T03=$(python -c \
421           "print(int(($vmdown-$relative_start)*1000))")
422         export DOCTOR_PROFILER_T04=$(python -c \
423           "print(int(($hostdown-$relative_start)*1000))")
424         export DOCTOR_PROFILER_T09=$(python -c \
425           "print(int(($notified-$relative_start)*1000))")
426
427         python profiler-poc.py >doctor_profiler.log 2>&1
428     fi
429 }
430
431 cleanup() {
432     set +e
433     echo "cleanup..."
434     stop_monitor
435     stop_inspector
436     stop_consumer
437
438     unset_forced_down_hosts
439     collect_logs
440
441     vms=$(openstack $as_doctor_user server list)
442     vmstodel=""
443     for i in `seq $VM_COUNT`; do
444         $(echo "${vms}" | grep -q " $VM_BASENAME$i ") &&
445         vmstodel+=" $VM_BASENAME$i"
446     done
447     [[ $vmstodel ]] && openstack $as_doctor_user server delete $vmstodel
448     alarm_list=$($ceilometer alarm-list)
449     for i in `seq $VM_COUNT`; do
450         alarm_id=$(echo "${alarm_list}" | grep " $ALARM_BASENAME$i " |
451                    awk '{print $2}')
452         [ -n "$alarm_id" ] && $ceilometer alarm-delete "$alarm_id"
453     done
454     openstack $as_doctor_user subnet delete $NET_NAME
455     sleep 1
456     openstack $as_doctor_user network delete $NET_NAME
457     sleep 1
458
459     image_id=$(openstack image list | grep " $IMAGE_NAME " | awk '{print $2}')
460     sleep 1
461     #if an existing image was used, there's no need to remove it here
462     if [[ "$use_existing_image" == false ]] ; then
463         [ -n "$image_id" ] && openstack image delete "$image_id"
464     fi
465
466     remove_test_user
467
468     cleanup_installer
469     cleanup_inspector
470
471     # NOTE: Temporal log printer.
472     for f in $(find . -name '*.log')
473     do
474         echo
475         echo "[$f]"
476         sed -e 's/^/ | /' $f
477         echo
478     done
479 }
480
481 # Main process
482
483 echo "Note: doctor/tests/run.sh has been executed."
484 git log --oneline -1 || true   # ignore even you don't have git installed
485
486 trap cleanup EXIT
487
488 source $TOP_DIR/functions-common
489 source $TOP_DIR/lib/installer
490 source $TOP_DIR/lib/inspector
491
492 setup_installer
493
494 echo "preparing VM image..."
495 download_image
496 register_image
497
498 echo "creating test user..."
499 create_test_user
500
501 echo "creating VM..."
502 boot_vm
503 wait_for_vm_launch
504
505 echo "creating alarm..."
506 #TODO: change back to use, network problems depends on infra and installers
507 #get_consumer_ip
508 create_alarm
509
510 echo "starting doctor sample components..."
511 start_inspector
512 start_monitor
513 start_consumer
514
515 sleep 60
516 echo "injecting host failure..."
517 inject_failure
518
519 check_host_status "(DOWN|UNKNOWN)" 60
520 calculate_notification_time
521 unset_forced_down_hosts
522 collect_logs
523 run_profiler
524
525 echo "done"